/*******************************************************************************
 * FoxUIFeaturedItemWidget generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxUIFeaturedItemWidget extends FoxUIBaseWidget within GFxMoviePlayer
    native(UI)
    config(UI);

var const config array<config string> FeaturedOfferTags;
var const config float DisplayTime;
var const config int nItemsPerPage;
var transient string ItemEntryClickFunc;
var private transient float CurrentDisplayTime;
var private transient int SelectedPageIndex;
var private transient int CachedPageCount;
var private transient int CachedItemCount;
var private transient array<StoreMetaData> FeaturedStoreItems;
var private transient bool bHidden;
var private transient bool bForceUpdate;
var private const localized string HeaderLabel;
var private const localized string PageLabel;

function Initialize()
{
    Bind();
    bForceUpdate = true;
    //return;    
}

protected function bool GetCachedItems()
{
    local FoxItemCacheStore StoreCache;
    local int ItemsPerPage;

    // End:0x105
    if((class'FoxDataStore_StoreData'.static.GetCachedStore(StoreCache) && StoreCache.GetCachedItems(FeaturedStoreItems,, FeaturedOfferTags,,, true)) && FeaturedStoreItems.Length > 0)
    {
        // End:0x103
        if(CachedItemCount != FeaturedStoreItems.Length)
        {
            CachedItemCount = FeaturedStoreItems.Length;
            ItemsPerPage = Max(nItemsPerPage, 1);
            CachedPageCount = CachedItemCount / ItemsPerPage;
            CachedPageCount += int((CachedPageCount * ItemsPerPage) < CachedItemCount);
        }
        return true;
    }
    return false;
    //return ReturnValue;    
}

event ShowNextPage(optional bool bShowPrev, optional int StartIndex)
{
    local int I, IndexIncrement;
    local bool bHasPage, bShowArrows;

    StartIndex = -1;
    // End:0x1A8
    if(GetCachedItems())
    {
        // End:0x4B
        if(bForceUpdate && ShowFeaturedItemPage(SelectedPageIndex))
        {
            bHasPage = true;
        }
        // End:0x15A
        else
        {
            // End:0x85
            if((StartIndex != -1) && ShowFeaturedItemPage(StartIndex))
            {
                bHasPage = true;
            }
            // End:0x15A
            else
            {
                // End:0xC0
                if((StartIndex < 0) || StartIndex >= CachedPageCount)
                {
                    StartIndex = SelectedPageIndex;
                }
                IndexIncrement = ((bShowPrev) ? -1 : 1);
                I = 0;
                J0xEA:
                // End:0x15A [Loop If]
                if(I < CachedPageCount)
                {
                    StartIndex = NextIndex(StartIndex, IndexIncrement);
                    // End:0x14C
                    if(ShowFeaturedItemPage(StartIndex))
                    {
                        bHasPage = true;
                        // [Explicit Break]
                        goto J0x15A;
                    }
                    ++ I;
                    // [Loop Continue]
                    goto J0xEA;
                }
            }
        }
        bShowArrows = bHasPage && CachedPageCount > 1;
        as_toggleLeftArrow(bShowArrows);
        as_toggleRightArrow(bShowArrows);
    }
    SetVisible(bHasPage);
    //return;    
}

protected function int NextIndex(int StartIndex, int IndexIncrement)
{
    StartIndex = (StartIndex + IndexIncrement) % CachedPageCount;
    return ((StartIndex < 0) ? StartIndex + CachedPageCount : StartIndex);
    //return ReturnValue;    
}

protected function bool ShowFeaturedItemPage(int PageIndex)
{
    local array<BaseStoreEntry> ItemEntries;
    local array<string> PageLabelTokens;
    local string FormattedPageLabel;

    // End:0x171
    if((PageIndex >= 0) && PageIndex < CachedPageCount)
    {
        Outer.Advance(0.0);
        PageLabelTokens = SplitString(PageLabel, "%d");
        // End:0xCC
        if(PageLabelTokens.Length == 3)
        {
            FormattedPageLabel = (((PageLabelTokens[0] $ string(PageIndex + 1)) $ PageLabelTokens[1]) $ string(CachedPageCount)) $ PageLabelTokens[2];
        }
        SetString("setLabel1", HeaderLabel);
        SetString("setLabel2", FormattedPageLabel);
        SelectedPageIndex = PageIndex;
        CurrentDisplayTime = 0.0;
        ReloadList(ItemEntries, SelectedPageIndex * nItemsPerPage, nItemsPerPage);
        as_updateDataProvider(ItemEntries);
        return true;
    }
    return false;
    //return ReturnValue;    
}

// Export UFoxUIFeaturedItemWidget::execReloadList(FFrame&, void* const)
protected native function ReloadList(out array<BaseStoreEntry> ItemEntries, int StartItemIndex, int nItems);

function SetVisible(bool bToggle)
{
    // End:0x4C
    if(bToggle != bHidden)
    {
        bHidden = bToggle;
        SetBool("_visible", bHidden);
    }
    //return;    
}

function AddLeftArrow(optional string ToolTip, optional string ExtInterfaceClickFunc)
{
    as_addLeftArrow(ToolTip, ExtInterfaceClickFunc);
    //return;    
}

function AddRightArrow(optional string ToolTip, optional string ExtInterfaceClickFunc)
{
    as_addRightArrow(ToolTip, ExtInterfaceClickFunc);
    //return;    
}

private final function as_updateDataProvider(const array<BaseStoreEntry> DataProvider)
{
    ActionScriptVoid("updateDataProvider");
    //return;    
}

private final function as_addLeftArrow(string ToolTip, string ExtInterfaceClickFunc)
{
    ActionScriptVoid("setupLeftArrow");
    //return;    
}

private final function as_addRightArrow(string ToolTip, string ExtInterfaceClickFunc)
{
    ActionScriptVoid("setupRightArrow");
    //return;    
}

private final function as_toggleLeftArrow(bool bShow)
{
    ActionScriptVoid("showLeftArrow");
    //return;    
}

private final function as_toggleRightArrow(bool bShow)
{
    ActionScriptVoid("showRightArrow");
    //return;    
}

defaultproperties
{
    FeaturedOfferTags(0)="Featured"
    FeaturedOfferTags(1)="Sale"
    FeaturedOfferTags(2)="BestSelling"
    nItemsPerPage=6
    bHidden=true
    HeaderLabel="FEATURED ITEMS"
    PageLabel="%d of %d"
}